#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "UObject/NoExportTypes.h"
#include "MapMarkerActor.generated.h"

class UFloatValueStrategy;
class AGenerator;

UCLASS(Blueprintable)
class AMapMarkerActor : public AActor
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FLinearColor _generatorAuraColor;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced, meta=(AllowPrivateAccess=true))
	UFloatValueStrategy* _generatorHighlightRange;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	TArray<AGenerator*> _revealedGenerators;

protected:
	UFUNCTION(BlueprintPure)
	bool ShouldShow() const;

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent)
	void BP_OnDestroy();

public:
	AMapMarkerActor();
};

FORCEINLINE uint32 GetTypeHash(const AMapMarkerActor) { return 0; }
